package myPackage.base;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.logging.Handler;
import java.util.logging.LogManager;
import java.util.logging.Logger;

import org.testng.annotations.BeforeSuite;


public class TestScript {
	
	private static Logger logger;
	
	public TestScript(){
		File logPropFile = new File(System.getProperty("user.dir") + "/resources/main/log.properties");
		readLogProp(logPropFile);
		logger = Logger.getLogger(TestScript .class.getName());
	}
	
	@BeforeSuite
	public void loadBeforeSuite() {		
		System.out.println("##########################################################");
		System.out.println("###################### @BeforeSuite method ###############");
		System.out.println("##########################################################");
		printAllLevels(logger);
		printLoggerInfo(logger);
		printLoggerInfo(logger.getParent());
	}
		
	public void printLoggerInfo(Logger log){
		System.out.println("---------------------------------------------------------");
		System.out.println("---------------------------------------------------------");
		System.out.println("Properties of logger with name: '" + log.getName() +"'");
		for(Handler h : log.getHandlers()){
			System.out.println("Handler of '" + log.getName() + "' logger: " + h );
		}
		System.out.println("Log level: " + log.getLevel());
		System.out.println("Log parent: " + log.getParent());
		System.out.println("---------------------------------------------------------");
		System.out.println("---------------------------------------------------------");
	}
	
	public void printAllLevels(Logger log){
		log.severe("Severe level");
		log.warning("Warning level");
		log.fine("Fine level");
		log.finer("Finer level");
		log.finest("Finest level");
	}
	
	private void readLogProp(File logPropFile){
		try {
			LogManager.getLogManager().readConfiguration(new FileInputStream(logPropFile));
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}	
	}
}
